#ifndef __LIB_EGPC_B4S1_H__
#define __LIB_EGPC_B4S1_H__

#include <windows.h> 

#define CANBUS_MAX_COMPORT_STR_LEN 6
#define CANBUS_MAX_DATA_SIZE	   8
#define	VER_LEN	                   16
#define	WARN_CODE				   0xFFFFFFFF

/* for "CanFrameInFor type" */
/*-----------------------------*/
enum
{
    CP_29Bit,
    CP_11Bit
};

/* for "CanFrameInFor rtr" */
/*-----------------------------*/
enum
{
    DISABLE_RTR,
    ENABLE_RTR
};

/* for "EGPCInitCAN status" */
/*-----------------------------*/
enum
{
    STS_INACTIVE,
    STS_ACTIVE
};

/* for "BaudRate" */
/*-----------------------------*/
#define EGPC_BAUDRATE_1M   1000000
#define EGPC_BAUDRATE_800K 800000
#define EGPC_BAUDRATE_500K 500000
#define EGPC_BAUDRATE_250K 250000
#define EGPC_BAUDRATE_100K 100000
#define EGPC_BAUDRATE_50K  50000
#define EGPC_BAUDRATE_20K  20000
#define EGPC_BAUDRATE_10K  10000

typedef struct
{
    int type;
    bool rtr;
    DWORD id;
    BYTE data_len;
    BYTE data[CANBUS_MAX_DATA_SIZE];

} CanFrameInfor;

typedef void(CALLBACK *CanFrameInforProc)(long error, CanFrameInfor* msg);

typedef long        (*EGPC_OPEN)            (char* sComPortNumber);
typedef long        (*EGPC_OPEN_INACTIVE)   (char* sComPortNumber);
typedef long        (*EGPC_INIT_CAN)        (char* sComPortNumber, int status);
typedef long        (*EGPC_CLOSE)           (char* sComPortNumber);
typedef long        (*EGPC_SET_BAUDRATE)    (char* sComPortNumber, DWORD BaudRate);             /* This function can be used in CAN inactive mode after using EGPCOpenInactive() */
typedef long        (*EGPC_GET_BAUDRATE)    (char* sComPortNumber, DWORD* BaudRate);
typedef long        (*EGPC_SET_FILTER)      (char* sComPortNumber, DWORD pattern, DWORD mask);  /* This function can be used in CAN inactive mode after using EGPCOpenInactive() */
typedef long        (*EGPC_CLEAR_FILTER)    (char* sComPortNumber);                             /* This function can be used in CAN inactive mode after using EGPCOpenInactive() */
typedef long        (*EGPC_RECEIVE)         (char* sComPortNumber, CanFrameInforProc callback);
typedef long        (*EGPC_SEND)            (char* sComPortNumber, CanFrameInfor* msg);         /* This function can be used in CAN   active mode after using EGPCOpenInactive() */
typedef long        (*EGPC_RESET)           (char* sComPortNumber);
typedef void        (*EGPC_SHOW_VER)        (char* ver_info);
typedef const char* (*EGPC_WARN_STR)        (void);
#endif